Object subclass: #Alquiler
	instanceVariableNames: 'fechaInicio fechaDevolucion cliente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!Alquiler methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:48'!
devolucionTardia
	^fechaDevolucion > (fechaInicio addDays: (self diasDeAlquiler)).! !

!Alquiler methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 21:42'!
diasDeAlquiler
	SubclassResponsibility signal.! !

!Alquiler methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:44'!
alquiladoMiercoles
	^fechaInicio weekday = #Wednesday.! !

!Alquiler methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:08'!
alquilerEmpresarial
	""" CUIT empresarial comienza con 26 """
	^cliente beginsWith: '26'! !


!Alquiler methodsFor: 'private' stamp: 'MPicco 5/17/2020 21:41'!
cliente: unCliente
	cliente := unCliente.! !

!Alquiler methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:03'!
fechaDevolucion: unaFecha
	fechaDevolucion := unaFecha.! !

!Alquiler methodsFor: 'private' stamp: 'MPicco 5/17/2020 21:41'!
importe
	SubclassResponsibility signal.! !

!Alquiler methodsFor: 'private' stamp: 'MPicco 5/17/2020 21:40'!
fechaInicio: unaFecha
	fechaInicio := unaFecha.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Alquiler class
	instanceVariableNames: ''!

!Alquiler class methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:03'!
conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente
	| alq |
	alq := self new.
	alq fechaInicio: unaFechaInicio.
	alq fechaDevolucion: unaFechaDevolucion.
	alq cliente: unCliente.
	^alq.! !


Alquiler subclass: #AlquilerPorDia
	instanceVariableNames: 'dias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!AlquilerPorDia methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:11'!
diasDeAlquiler
	^dias.! !

!AlquilerPorDia methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:10'!
dias: unaCantidad
	dias := unaCantidad.! !

!AlquilerPorDia methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:12'!
importe
	^2000 * dias.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AlquilerPorDia class
	instanceVariableNames: ''!

!AlquilerPorDia class methodsFor: 'accessing' stamp: 'MPicco 5/17/2020 22:10'!
porDias: unaCantidad conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente
	| alq |
	alq := self conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente.
	alq dias: unaCantidad.
	^alq.! !


Alquiler subclass: #AlquilerPorHora
	instanceVariableNames: 'horas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!AlquilerPorHora methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:12'!
diasDeAlquiler
	^horas / 24.! !

!AlquilerPorHora methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:26'!
horas: unaCantidad
	horas := unaCantidad.! !

!AlquilerPorHora methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:12'!
importe
	^100 * horas.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AlquilerPorHora class
	instanceVariableNames: ''!

!AlquilerPorHora class methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:11'!
porHoras: unaCantidad conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente
	| alq |
	alq := self conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente.
	alq horas: unaCantidad.
	^alq.! !


Alquiler subclass: #AlquilerPorKilometro
	instanceVariableNames: 'kilometros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!AlquilerPorKilometro methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:14'!
diasDeAlquiler
	""" Para este ejercicio se asume que se devuelve en el mismo dia """
	^0.! !

!AlquilerPorKilometro methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:44'!
kilometros: unaCantidad
	kilometros := unaCantidad.! !

!AlquilerPorKilometro methodsFor: 'private' stamp: 'MPicco 5/17/2020 22:14'!
importe
	^100 + (10 * kilometros).! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AlquilerPorKilometro class
	instanceVariableNames: ''!

!AlquilerPorKilometro class methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:13'!
porKilometros: unaCantidad conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente
	| alq |
	alq := self conFechaInicio: unaFechaInicio fechaDevolucion: unaFechaDevolucion yCliente: unCliente.
	alq kilometros: unaCantidad.
	^alq.! !


Object subclass: #CarRental
	instanceVariableNames: 'reglasDeFacturacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!CarRental methodsFor: 'initialization' stamp: 'MPicco 5/17/2020 21:34'!
initialize
	reglasDeFacturacion := OrderedCollection new.! !


!CarRental methodsFor: 'private ' stamp: 'MPicco 5/17/2020 21:33'!
reglasDeFacturacion: reglas
	reglasDeFacturacion := reglas! !

!CarRental methodsFor: 'private ' stamp: 'MPicco 5/17/2020 22:34'!
importePara: unAlquiler
	| importe adicional |
	importe := unAlquiler importe.
	
	adicional := reglasDeFacturacion inject: 0 into: [ :suma :regla | suma + (regla aplicar: unAlquiler) ].
	
	^importe + adicional.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CarRental class
	instanceVariableNames: ''!

!CarRental class methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 21:33'!
conReglasDeFacturacion: reglas
	| carRental |
	carRental := self new.
	carRental reglasDeFacturacion: reglas.
	^carRental.! !


Object subclass: #DescuentoPorEmpresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!DescuentoPorEmpresa methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:18'!
aplicar: unAlquiler
	""" Descuenta el 5% """
	unAlquiler alquilerEmpresarial ifTrue: [ ^(-0.05 * unAlquiler importe) ].
	^0.	! !


Object subclass: #DescuentoPorMiercoles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!DescuentoPorMiercoles methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:19'!
aplicar: unAlquiler
	""" Descuento fijo de 50$ """
	unAlquiler alquiladoMiercoles ifTrue: [ ^(-50) ].
	^0.! !


Object subclass: #PenalizacionPorDevolucionTardia
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRental'!

!PenalizacionPorDevolucionTardia methodsFor: 'as yet unclassified' stamp: 'MPicco 5/17/2020 22:52'!
aplicar: unAlquiler
	unAlquiler devolucionTardia ifTrue: [ ^unAlquiler importe  ].
	^0.! !
