TestCase subclass: #AlquilerPorHoraTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRentalTest'!

!AlquilerPorHoraTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:55'!
test02AlquilerPorHoraPor48HorasEntregadoAlDiaSiguienteNoFueEntregadoTarde
	| alq fechaInicio fechaDevolucion |
	fechaInicio := Date year: 2020 month: 05 day: 20.
	fechaDevolucion := fechaInicio addDays: 1.
	alq := AlquilerPorHora porHoras: 48 conFechaInicio: fechaInicio fechaDevolucion: fechaDevolucion yCliente: '201234567890'.
	
	self deny: alq devolucionTardia.! !

!AlquilerPorHoraTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:55'!
test03AlquilerPorHoraPor48HorasEntregadoALosTresDiasFueEntregadoTarde
	| alq fechaInicio fechaDevolucion |
	fechaInicio := Date year: 2020 month: 05 day: 20.
	fechaDevolucion := fechaInicio addDays: 3.
	alq := AlquilerPorHora porHoras: 48 conFechaInicio: fechaInicio fechaDevolucion: fechaDevolucion yCliente: '201234567890'.
	
	self assert: alq devolucionTardia.! !

!AlquilerPorHoraTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:48'!
test01AlquilerPorHoraPor48HorasValePorDosDias
	| alq dias |
	alq := AlquilerPorHora porHoras: 48 conFechaInicio: (Date today) fechaDevolucion: (Date today) yCliente: '201234567890'.
	
	dias := alq diasDeAlquiler.
	
	self assert: dias equals: 2.! !


TestCase subclass: #AlquilerPorKilometroTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRentalTest'!

!AlquilerPorKilometroTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:44'!
test01AlquilerPorKilometroConFechaInicioMiercolesDevuelveVerdaderoAlConsultarSiFueAlquiladoUnMiercoles
	| alq fecha |
	fecha := Date year: 2020 month: 05 day: 20.
	alq := AlquilerPorKilometro porKilometros: 200 conFechaInicio: fecha fechaDevolucion: fecha yCliente: '201234567890'.
	
	self assert: alq alquiladoMiercoles.! !


TestCase subclass: #CarRentalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRentalTest'!

!CarRentalTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:39'!
test03CarRentalConDescuentoPorMiercolesYPenalizacionPorDevolucionTardiaCalculaElImporteParaUnAlquilerPorHoraDevueltoTarde
	| carRental reglas alquilerPorHora monto fechaInicio fechaDevolucion |
	reglas := OrderedCollection new.
	reglas add: DescuentoPorMiercoles new.
	reglas add: PenalizacionPorDevolucionTardia new.
	carRental := CarRental conReglasDeFacturacion: reglas.
	fechaInicio := Date year: 2020 month: 5 day: 20.
	fechaDevolucion := fechaInicio addDays: 2.
	""" Devuelto un dia tarde """
	alquilerPorHora := AlquilerPorHora porHoras: 24 conFechaInicio: fechaInicio fechaDevolucion: fechaDevolucion yCliente: '201234567890'.
	
	monto := carRental importePara: alquilerPorHora.
	
	""" (100*24) - 50 + (100*24)  """
	self assert: monto equals: 4750.! !

!CarRentalTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:49'!
test02CarRentalConDescuentoPorEmpresaCalculaElImporteParaUnAlquilerDeDosDias
	| carRental descuentoPorEmpresa alquilerPorDia monto |
	descuentoPorEmpresa := DescuentoPorEmpresa new.
	carRental := CarRental conReglasDeFacturacion: (OrderedCollection with: descuentoPorEmpresa).
	alquilerPorDia := AlquilerPorDia porDias: 2 conFechaInicio: (Date today) fechaDevolucion: (Date today) yCliente: '261234567890'.
	
	monto := carRental importePara: alquilerPorDia.
	
	""" 5% de 2dias*2000$/dia  """
	self assert: monto equals: 3800.! !

!CarRentalTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:27'!
test01CarRentalSinDescuentosNiPenalizacionesCalculaElImporteParaUnAlquilerDeTresHoras
	| carRental alquilerPorDia monto |
	carRental := CarRental conReglasDeFacturacion: OrderedCollection new.
	alquilerPorDia := AlquilerPorHora porHoras: 3 conFechaInicio: (Date today) fechaDevolucion: (Date today) yCliente: '201234567890'.
	
	monto := carRental importePara: alquilerPorDia.
	
	self assert: monto equals: 300.! !


TestCase subclass: #DescuentoPorEmpresaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRentalTest'!

!DescuentoPorEmpresaTest methodsFor: 'tests' stamp: 'MPicco 5/18/2020 18:14'!
test02DescuentoPorEmpresaCalculaDescuentoParaUnAlquilerPorKilometroPor500KilometrosConClienteEmpresarial
	| descuento alq monto |
	alq := AlquilerPorKilometro porKilometros: 500 conFechaInicio: (Date today) fechaDevolucion: (Date today) yCliente: '261234567890'. 
	descuento := DescuentoPorEmpresa new.
	
	monto := descuento aplicar: alq.
	
	self assert: monto equals: -255.! !

!DescuentoPorEmpresaTest methodsFor: 'tests' stamp: 'MPicco 5/18/2020 18:16'!
test01DescuentoPorEmpresaCalculaDescuentoParaUnAlquilerPorKilometroPor500Kilometros
	| descuento alq monto |
	alq := AlquilerPorKilometro porKilometros: 500 conFechaInicio: (Date today) fechaDevolucion: (Date today) yCliente: '201234567890'. 
	descuento := DescuentoPorEmpresa new.
	
	monto := descuento aplicar: alq.
	
	self assert: monto equals: 0.! !


TestCase subclass: #PenalizacionPorDevolucionTardiaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CarRentalTest'!

!PenalizacionPorDevolucionTardiaTest methodsFor: 'tests' stamp: 'MPicco 5/17/2020 22:54'!
test01PenalizacionPorDevolucionTardiaCalculaElMontoParaAlquilerPorHoraEntregadoATiempo
	| penalizacion alq fechaInicio fechaDevolucion monto |
	fechaInicio := Date year: 2020 month: 05 day: 20.
	fechaDevolucion := fechaInicio addDays: 1.
	alq := AlquilerPorHora porHoras: 48 conFechaInicio: fechaInicio fechaDevolucion: fechaDevolucion yCliente: '201234567890'.
	penalizacion := PenalizacionPorDevolucionTardia new.
	
	monto := penalizacion aplicar: alq.
	
	""" 48hs * 100$/hs """
	self assert: monto equals: 0.! !

!PenalizacionPorDevolucionTardiaTest methodsFor: 'tests' stamp: 'MPicco 5/18/2020 18:23'!
test02PenalizacionPorDevolucionTardiaCalculaElMontoParaAlquilerPorHoraPor48HorasEntregadoALosTresDias
	| penalizacion alq fechaInicio fechaDevolucion monto |
	fechaInicio := Date year: 2020 month: 05 day: 20.
	fechaDevolucion := fechaInicio addDays: 3.
	alq := AlquilerPorHora porHoras: 48 conFechaInicio: fechaInicio fechaDevolucion: fechaDevolucion yCliente: '201234567890'.
	penalizacion := PenalizacionPorDevolucionTardia new.
	
	monto := penalizacion aplicar: alq.
	
	""" 48hs * 100$/hs """
	self assert: monto equals: (alq importe).! !
